// By. Joey Clemente

#version 330                          
layout (location = 0) in vec3 in_Pos;  
layout (location = 1) in vec3 in_Color;
layout (location = 2) in vec2 in_TexCoords; 
layout (location = 3) in vec3 in_Normals;

out vec3 Color;
out vec3 WorldPos;
out vec3 WorldNormal;

uniform mat4 uModel;
uniform mat4 uView;
uniform mat4 uProjection;
uniform sampler2D noise;
uniform float iTime;

void main(){
    float perlinValue = texture(noise, in_TexCoords).r * 2 - 1;
    Color = in_Color;
    gl_Position = uProjection * uView * uModel * vec4(in_Pos.x, in_Pos.y + (perlinValue * sin(iTime) * .05f), in_Pos.z,1.0);
    WorldPos = vec3(uModel * vec4(in_Pos.x, in_Pos.y + (perlinValue * sin(iTime) * .05f), in_Pos.z,1.0));
    WorldNormal = mat3(transpose(inverse(uModel))) * in_Normals;
}
